/*->h.dc     */

#define STRLEN 32
#define STRMAX 31
#define KEYLEN 8
#define MINTOK 31
#define ESCTOK 30

typedef struct
{
 char name[24];
 char  mark[8];
 char copy[64];
 int  capabilities;
 char stuff[156];
} dheader;


typedef struct dict
{
 unsigned int               nowords;
 unsigned int               noindex;
 memblock * index;
 memblock * words;
} dict;


typedef struct word
{
 char          string[STRLEN];    /* the word                */
 unsigned int  woffset;           /* offset of start of word */
 int           indexn;            /* number of index         */
 unsigned      wordn;             /* word number             */
 int           len;               /* bytes in word woffset+len==next word */
} word;



typedef struct index
{
 unsigned int woffset;       /* offset of first word indexed */
 unsigned int wordn;         /* number of first word indexed */
 char         key[KEYLEN];   /* string of characters         */
} index;



#define SETWOFF(indexp,woff) ((indexp)->woffset=(unsigned int)(woff))

#define WOFF(indexp)   ((indexp)->woffset)


#define SETWORDN(indexp,wordnv) ((indexp)->wordn=(unsigned int)(wordnv))

#define WORDN(indexp)   ((indexp)->wordn)



extern os_error * addword(char * word,dict * dp);
extern os_error * savedc(char * path,char * name,dict * dp);
extern os_error * loaddc(char * path,char * name,dict * dp);
extern void   trashdc(dict * dp);
extern int    deleteword(char * word,dict * dp);
extern int    nowords(dict * dp);
extern char * wordn(int n,dict * dp);
extern int    locword(int seekn,dict * dp,word * words);
extern int    nextword(dict * dp,word * words);
extern void   createdc(dict * dp);
extern int    findword(char * string,dict * dp,word * words,int * flags);
extern int    formword(dict * dp,word * words);
extern int    remword(dict * dp,word * words);


extern char * mfx[256];


extern int xstrncmp(char * s1,char * s2,int max,int * flags);

/* compares at most max chars of two strings  */
/* flags output 0x1    - mismatched case      */
/* flags input  0x1000 - ignore hyphens       */


#define DCIGNOREHYPHEN 0x1000
#define DCIGNORESPACE  0x2000


extern int xscanword(char * string,int * flags,char * subs,char * dcspc);

extern int xgetscanstring(char * string);

extern void testdict(dict * dp);

