/*->c.memblock */



#include "stdafx.h"

#include <stdlib.h>
#include <stdarg.h>
#include <string.h>
#include <stdio.h>
#include <locale.h>

#include "os.h"
#include "wimp.h"
#include "wimpt.h"
#include "werr.h"
#include "transform.h"

#include "wos.h"
#include "err.h"
#include "task.h"
#include "poll.h"
#include "temp.h"
#include "scrap.h"
#include "fsx.h"
#include "conf.h"
#include "etc.h"
#include "flex.h"
#include "deb.h"
#include "appinfo.h"
#include "mlo.h"
#include "osunits.h"
#include "colour.h"
#include "xmath.h"
#include "bf.h"


#include "memblock.h"



os_error * createblock(memblock ** anchor,int size)
{
 return(flex_alloc((flex_ptr)anchor,size));
}




os_error * deleteblock(memblock ** anchor)
{
 return(flex_free((flex_ptr)anchor));
}




os_error * alterblock(memblock ** anchor,int offset,int n)
{
 if(n<0) offset=offset-n;
 
 return(flex_midextend((flex_ptr)anchor,offset,n));
}




char * charblock(memblock * anchor,int offset)
{
 return(((char*)anchor)+offset);
}




os_error * setsizeblock(memblock ** anchor,int newsize)
{
 return(flex_extend((flex_ptr)anchor,newsize));
}



typedef struct Ovnbuffer
{
  struct Ovnbuffer ** anchor;  /* this points at the anchor in the source   */
  int     len;                 /* amount of stuff in buffer */
  int     maxlen;              /* maximum length of buffer  */
  int     previous;            /* offset of previous buffer */
  int     goffset;             /* offset of gap in buffer   */
  char    buff[4];             /* character buffer          */
} Ovnbuffer;




os_error * savememblock(memblock ** anchor,buffer * bf)
{
 os_error * err;
 int        size;
 int        bsize;
 Ovnbuffer  Obuffer;

 err=flex_size((flex_ptr)anchor,&size);
 if(!err)
 {
  bsize=size+sizeof(Ovnbuffer)-4;
  Obuffer.len=Obuffer.maxlen=Obuffer.goffset=bsize;
  Obuffer.previous=0;
  Obuffer.anchor=NULL;

  err=bf_write(bf,&Obuffer,sizeof(Ovnbuffer)-4);
  if(!err) err=bf_write(bf,*anchor,size);
 }
 return(err);
}




os_error * loadmemblock(memblock ** anchor,buffer * bf)
{
 os_error * err;
 Ovnbuffer  Obuffer;
 int        size;

 err=bf_read(bf,&Obuffer,sizeof(Ovnbuffer)-4);
 if(!err)
 {
  size=Obuffer.len-(sizeof(Ovnbuffer)-4);
  err=flex_alloc((flex_ptr)anchor,size);
  if(!err) err=bf_read(bf,*anchor,size);
 }

 return(err);
}




os_error * relocmemblock(memblock ** oldanchor,memblock ** newanchor)
{

 return(flex_swop((flex_ptr)oldanchor,(flex_ptr)newanchor));
}






